TPM_ALG_IDS = {
    0x0001: "TPM2_ALG_RSA",
    0x0004: "TPM2_ALG_SHA",
    # Two identical ids
    # 0x0004: "TPM2_ALG_SHA1",
    0x0005: "TPM2_ALG_HMAC",
    0x0006: "TPM2_ALG_AES",
    0x0007: "TPM2_ALG_MGF1",
    0x0008: "TPM2_ALG_KEYEDHASH",
    0x000A: "TPM2_ALG_XOR",
    0x000B: "TPM2_ALG_SHA256",
    0x000C: "TPM2_ALG_SHA384",
    0x000D: "TPM2_ALG_SHA512",
    0x0010: "TPM2_ALG_NULL",
    0x0012: "TPM2_ALG_SM3_256",
    0x0013: "TPM2_ALG_SM4",
    0x0014: "TPM2_ALG_RSASSA",
    0x0015: "TPM2_ALG_RSAES",
    0x0016: "TPM2_ALG_RSAPSS",
    0x0017: "TPM2_ALG_OAEP",
    0x0018: "TPM2_ALG_ECDSA",
    0x0019: "TPM2_ALG_ECDH",
    0x001A: "TPM2_ALG_ECDAA",
    0x001B: "TPM2_ALG_SM2",
    0x001C: "TPM2_ALG_ECSCHNORR",
    0x001D: "TPM2_ALG_ECMQV",
    0x0020: "TPM2_ALG_KDF1_SP800_56A",
    0x0021: "TPM2_ALG_KDF2",
    0x0022: "TPM2_ALG_KDF1_SP800_108",
    0x0023: "TPM2_ALG_ECC",
    0x0025: "TPM2_ALG_SYMCIPHER",
    0x0026: "TPM2_ALG_CAMELLIA",
    0x003F: "TPM2_ALG_CMAC",
    0x0040: "TPM2_ALG_CTR",
    0x0027: "TPM2_ALG_SHA3_256",
    0x0028: "TPM2_ALG_SHA3_384",
    0x0029: "TPM2_ALG_SHA3_512",
    0x0041: "TPM2_ALG_OFB",
    0x0042: "TPM2_ALG_CBC",
    0x0043: "TPM2_ALG_CFB",
    0x0044: "TPM2_ALG_ECB",
}

TPM_CC_IDS = {
    0x0000011F: "TPM2_CC_NV_UndefineSpaceSpecial",
    0x00000120: "TPM2_CC_EvictControl",
    0x00000121: "TPM2_CC_HierarchyControl",
    0x00000122: "TPM2_CC_NV_UndefineSpace",
    0x00000124: "TPM2_CC_ChangeEPS",
    0x00000125: "TPM2_CC_ChangePPS",
    0x00000126: "TPM2_CC_Clear",
    0x00000127: "TPM2_CC_ClearControl",
    0x00000128: "TPM2_CC_ClockSet",
    0x00000129: "TPM2_CC_HierarchyChangeAuth",
    0x0000012A: "TPM2_CC_NV_DefineSpace",
    0x0000012B: "TPM2_CC_PCR_Allocate",
    0x0000012C: "TPM2_CC_PCR_SetAuthPolicy",
    0x0000012D: "TPM2_CC_PP_Commands",
    0x0000012E: "TPM2_CC_SetPrimaryPolicy",
    0x0000012F: "TPM2_CC_FieldUpgradeStart",
    0x00000130: "TPM2_CC_ClockRateAdjust",
    0x00000131: "TPM2_CC_CreatePrimary",
    0x00000132: "TPM2_CC_NV_GlobalWriteLock",
    0x00000133: "TPM2_CC_GetCommandAuditDigest",
    0x00000134: "TPM2_CC_NV_Increment",
    0x00000135: "TPM2_CC_NV_SetBits",
    0x00000136: "TPM2_CC_NV_Extend",
    0x00000137: "TPM2_CC_NV_Write",
    0x00000138: "TPM2_CC_NV_WriteLock",
    0x00000139: "TPM2_CC_DictionaryAttackLockReset",
    0x0000013A: "TPM2_CC_DictionaryAttackParameters",
    0x0000013B: "TPM2_CC_NV_ChangeAuth",
    0x0000013C: "TPM2_CC_PCR_Event",
    0x0000013D: "TPM2_CC_PCR_Reset",
    0x0000013E: "TPM2_CC_SequenceComplete",
    0x0000013F: "TPM2_CC_SetAlgorithmSet",
    0x00000140: "TPM2_CC_SetCommandCodeAuditStatus",
    0x00000141: "TPM2_CC_FieldUpgradeData",
    0x00000142: "TPM2_CC_IncrementalSelfTest",
    0x00000143: "TPM2_CC_SelfTest",
    0x00000144: "TPM2_CC_Startup",
    0x00000145: "TPM2_CC_Shutdown",
    0x00000146: "TPM2_CC_StirRandom",
    0x00000147: "TPM2_CC_ActivateCredential",
    0x00000148: "TPM2_CC_Certify",
    0x00000149: "TPM2_CC_PolicyNV",
    0x0000014A: "TPM2_CC_CertifyCreation",
    0x0000014B: "TPM2_CC_Duplicate",
    0x0000014C: "TPM2_CC_GetTime",
    0x0000014D: "TPM2_CC_GetSessionAuditDigest",
    0x0000014E: "TPM2_CC_NV_Read",
    0x0000014F: "TPM2_CC_NV_ReadLock",
    0x00000150: "TPM2_CC_ObjectChangeAuth",
    0x00000151: "TPM2_CC_PolicySecret",
    0x00000152: "TPM2_CC_Rewrap",
    0x00000153: "TPM2_CC_Create",
    0x00000154: "TPM2_CC_ECDH_ZGen",
    0x00000155: "TPM2_CC_HMAC",
    0x00000156: "TPM2_CC_Import",
    0x00000157: "TPM2_CC_Load",
    0x00000158: "TPM2_CC_Quote",
    0x00000159: "TPM2_CC_RSA_Decrypt",
    0x0000015B: "TPM2_CC_HMAC_Start",
    0x0000015C: "TPM2_CC_SequenceUpdate",
    0x0000015D: "TPM2_CC_Sign",
    0x0000015E: "TPM2_CC_Unseal",
    0x00000160: "TPM2_CC_PolicySigned",
    0x00000161: "TPM2_CC_ContextLoad",
    0x00000162: "TPM2_CC_ContextSave",
    0x00000163: "TPM2_CC_ECDH_KeyGen",
    0x00000164: "TPM2_CC_EncryptDecrypt",
    0x00000165: "TPM2_CC_FlushContext",
    0x00000167: "TPM2_CC_LoadExternal",
    0x00000168: "TPM2_CC_MakeCredential",
    0x00000169: "TPM2_CC_NV_ReadPublic",
    0x0000016A: "TPM2_CC_PolicyAuthorize",
    0x0000016B: "TPM2_CC_PolicyAuthValue",
    0x0000016C: "TPM2_CC_PolicyCommandCode",
    0x0000016D: "TPM2_CC_PolicyCounterTimer",
    0x0000016E: "TPM2_CC_PolicyCpHash",
    0x0000016F: "TPM2_CC_PolicyLocality",
    0x00000170: "TPM2_CC_PolicyNameHash",
    0x00000171: "TPM2_CC_PolicyOR",
    0x00000172: "TPM2_CC_PolicyTicket",
    0x00000173: "TPM2_CC_ReadPublic",
    0x00000174: "TPM2_CC_RSA_Encrypt",
    0x00000176: "TPM2_CC_StartAuthSession",
    0x00000177: "TPM2_CC_VerifySignature",
    0x00000178: "TPM2_CC_ECC_Parameters",
    0x00000179: "TPM2_CC_FirmwareRead",
    0x0000017A: "TPM2_CC_GetCapability",
    0x0000017B: "TPM2_CC_GetRandom",
    0x0000017C: "TPM2_CC_GetTestResult",
    0x0000017D: "TPM2_CC_Hash",
    0x0000017E: "TPM2_CC_PCR_Read",
    0x0000017F: "TPM2_CC_PolicyPCR",
    0x00000180: "TPM2_CC_PolicyRestart",
    0x00000181: "TPM2_CC_ReadClock",
    0x00000182: "TPM2_CC_PCR_Extend",
    0x00000183: "TPM2_CC_PCR_SetAuthValue",
    0x00000184: "TPM2_CC_NV_Certify",
    0x00000185: "TPM2_CC_EventSequenceComplete",
    0x00000186: "TPM2_CC_HashSequenceStart",
    0x00000187: "TPM2_CC_PolicyPhysicalPresence",
    0x00000188: "TPM2_CC_PolicyDuplicationSelect",
    0x00000189: "TPM2_CC_PolicyGetDigest",
    0x0000018A: "TPM2_CC_TestParms",
    0x0000018B: "TPM2_CC_Commit",
    0x0000018C: "TPM2_CC_PolicyPassword",
    0x0000018D: "TPM2_CC_ZGen_2Phase",
    0x0000018E: "TPM2_CC_EC_Ephemeral",
    0x0000018F: "TPM2_CC_PolicyNvWritten",
    0x00000190: "TPM2_CC_PolicyTemplate",
    0x00000191: "TPM2_CC_CreateLoaded",
    0x00000192: "TPM2_CC_PolicyAuthorizeNV",
    0x00000193: "TPM2_CC_EncryptDecrypt2",
    0x00000194: "TPM2_CC_AC_GetCapability",
    0x00000195: "TPM2_CC_AC_Send",
    0x00000196: "TPM2_CC_Policy_AC_SendSelect",
}

TPM_ECC_IDS = {
    0x0001: "TPM2_ECC_NIST_P192",
    0x0002: "TPM2_ECC_NIST_P224",
    0x0003: "TPM2_ECC_NIST_P256",
    0x0004: "TPM2_ECC_NIST_P384",
    0x0005: "TPM2_ECC_NIST_P521",
    0x0010: "TPM2_ECC_BN_P256",
    0x0011: "TPM2_ECC_BN_P638",
    0x0020: "TPM2_ECC_SM2_P256",
}
